
create database people
go

use people
go

create table person (
  id int primary key,
  firstname nvarchar(20),
  lastname nvarchar(30),
  age int
)
go

create procedure add_person (
  @in_id int, 
  @in_fname nvarchar(20), 
  @in_lname nvarchar(30),
  @in_age int
)
as
insert person values(@in_id, @in_fname, @in_lname, @in_age)
go

create procedure delete_person(@in_id int)
as
delete person where id = @in_id
go

create procedure update_person (
  @in_id int, 
-- lets be optimistic
--  @in_old_fname nvarchar(20), 
--  @in_old_lname nvarchar(30),
--  @in_old_age int,
  @in_new_fname nvarchar(20), 
  @in_new_lname nvarchar(30),
  @in_new_age int
)
as
update person set
 firstname = @in_new_fname,
 lastname  = @in_new_lname,
 age       = @in_new_age
where
 id        = @in_id  -- and
 -- firstname = @in_old_fname and
 -- lastname  = @in_old_lname and
 -- age       = @in_old_age
go

exec add_person 1, N'Bob', N'Jones', 43
select * from person
exec update_person 1, N'Fred', N'Smith', 66
select * from person
exec delete_person 3
select * from person
go

exec add_person 1, N'Bob', N'Jones', 43
exec add_person 2, N'Fred', N'Smith', 66
select * from person
go

exec people.dbo.delete_person 1